// FILENAME:	DM_The_Orb.cs
//
// AUTHOR:  	Gen. Stormtrooper [M.I.B.]
//------------------------------------------------------------------------------

// this var 
$missionName = "DM_The_Orb";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
      $ball = getObjectId("MissionGroup\\hit");
      track();
	iceSounds();
	avalancheSounds();
	meteorSounds();
	earthquakeSounds();
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to DeathMatch The Orb! You can download this & other missions made by Gen. Stormtrooper [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.<n>Warning: The orb is dangerous!");
}

function onMissionLoad()
{
   cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
	if((%message!="") && (getHUDName(%destroyer) == "unknown"))
	{
		%him = getHUDName(%destroyed);
		say(0, 0, " " @ %him @ " has beed destroyed by <F6>The Orb");
	}

	else if(%message!="")
	{
		say(0, 0, %message);
	}
}


function track()
{
   %xmov = getPosition($ball, x) + randomInt(-5, 5);
   %ymov =  getPosition($ball, y) + randomInt(-5, 5);
   %pop = randomInt(0, 180);
   %z = getTerrainHeight(%xmov, %ymov) + 5;

        if((%ymov > 3618) && (%xmov > 707))
	{
		%ymove = %ymov - 10;
		%xmove = %xmov - 10;
		setPosition($ball, %xmove, %ymove, %z);
	}

        else if((%ymov < 2934) && (%xmov < 216))
	{
		%ymove = %ymov + 10;
		%xmove = %xmov + 10;
		setPosition($ball, %xmove, %ymove, %z);
	}

        else if((%ymov < 2934) && (%xmov > 707))
	{
		%ymove = %ymov + 10;
		%xmove = %xmov - 10;
		setPosition($ball, %xmove, %ymove, %z);
	}

        else if((%ymov > 3618) && (%xmov < 216))
	{
		%ymove = %ymov - 10;
		%xmove = %xmov + 10;
		setPosition($ball, %xmove, %ymove, %z);
	}

	else if(%ymov < 2934)
	{
		%ymove = %ymov + 10;
		setPosition($ball, %xmov, %ymove, %z);
	}

	else if(%ymov > 3618)
	{
		%ymove = %ymov - 10;
		setPosition($ball, %xmov, %ymove, %z);
	}

	else if(%xmov > 707)
	{
		%xmove = %xmov - 10;
		setPosition($ball, %xmove, %ymov, %z);
	}

	else if(%xmov < 216)
	{
		%xmove = %xmov + 3;
		setPosition($ball, %xmove, %ymov, %z);
	}

	else
	{
		setPosition($ball, %xmov, %ymov, %z, %pop);
	}

   damageArea($ball, 0, 0, 0, 25, 300);
   schedule("track(%pop);", 0.1 );
}